import { Md5 } from "ts-md5";
export class GravatarWc {
    constructor() {
        this.email = "";
    }
    render() {
        const hash = this.getEmailHash();
        const scheme = this.protocol ? `${this.protocol}://` : "//";
        const params = {
            default: this.default,
            forcedefault: this.forceDefault && "y",
            rating: this.rating,
            size: this.size,
        };
        const queryString = Object.entries(params)
            .filter(([, v]) => v)
            .map(([k, v]) => `${k}=${v}`)
            .join("&");
        const src = `${scheme}gravatar.com/avatar/${hash}?${queryString}`;
        return h("img", { src: src, alt: "" });
    }
    getEmailHash() {
        const trimmed = this.email.trim();
        const lower = trimmed.toLocaleLowerCase();
        return Md5.hashStr(lower).toString();
    }
    static get is() { return "gravatar-wc"; }
    static get properties() { return {
        "default": {
            "type": String,
            "attr": "default"
        },
        "email": {
            "type": String,
            "attr": "email"
        },
        "forceDefault": {
            "type": Boolean,
            "attr": "force-default"
        },
        "protocol": {
            "type": String,
            "attr": "protocol"
        },
        "rating": {
            "type": String,
            "attr": "rating"
        },
        "size": {
            "type": Number,
            "attr": "size"
        }
    }; }
}
